/* fact64 v1.0 - small program calculate factorials using 64 bit integers
 *
 * Copyright (C) 2004 Giuseppe Caulo <giusc@softzone.it>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#ifdef _WIN32
# define uint64 __int64;
#else
# define uint64 long long;
#endif

unsigned int fmt_uint64(char *s, uint64 u)
{
  unsigned int len = 1;
  uint64 q = u;
  while (q > 9) { ++len; q /= 10; }
  if (s) { s += len; do { *--s = '0' + (u % 10); u /= 10; } while(u); }
  return len;
}

uint64 fatt64 (uint64 n)
{
  if(n==1||n==0)
    return (1);
  else
    n*=fatt64(n-1);
  return(n);
}

int main(void)
{
  unsigned long input;
  unsigned int buflen;
  uint64 input64, fact64;
  char buf[512];
  printf("\nFact64 v1.0 - Calculate factorials using 64 bit integers\n" );
  printf("Copyright (C) 2004-2005 Giuseppe Caulo\n");
  printf("Softzone - www.softzone.it\n\n");

  printf("Inserisci un intero\n");
  scanf("%lu", &input);
  input64 = input;
  fact64 = fatt64(input64);
  buflen = fmt_uint64(buf, fact64); buf[buflen] = 0;
  printf("Il fattoriale64 di %d  %s\n", input, buf);
}
